
s = <<EOF
<?xml version="1.0" encoding="utf-8"?>

<scene>
	<camera>
		<pos>0 -5 2</pos>
		<up>0 0 1</up>
		<forwards>0 1 -0.2</forwards>

		<aperture_radius>0.001</aperture_radius>
		<focus_distance>3.0</focus_distance>
		<aspect_ratio>1.33</aspect_ratio>
		<sensor_width>0.036</sensor_width>
		<lens_sensor_dist>0.04</lens_sensor_dist>
		<white_balance>D65</white_balance>
	</camera>
	
	<tonemapping>
		<reinhard>
			<pre_scale>1.0</pre_scale>
			<post_scale>1.0</post_scale>
		</reinhard>
	</tonemapping>
	
	<background>
		<spectrum>  
			<blackbody>
				<temperature>5000</temperature>
				<gain>0.00001</gain>
			</blackbody>
		</spectrum>
	</background>
	
	<rectanglelight>
		<pos>0 0 5</pos>
		<width>0.1</width>
		<height>0.1</height>
		
		<spectrum>
			<blackbody>
				<temperature>6500</temperature>
				<gain>1</gain>
			</blackbody>
		</spectrum>		
	</rectanglelight>
	
	<!--Ground Plane-->
	<material>
		<name>white</name>
		
		<diffuse>
			<colour>0.6 0.6 0.6</colour>
		</diffuse>
	</material>
	
	<mesh>
		<name>groundmesh</name>
		<normal_smoothing>false</normal_smoothing>
		<embedded>
			<expose_uv_set>
				<index>0</index>
				<name>albedo</name>
			</expose_uv_set>

			<vertex pos="-10 -10 0" normal="0 0 1" uv0="0 0" />
			<vertex pos="-10 10 0" normal="0 0 1" uv0="0 10000" />
			<vertex pos="10 10 0" normal="0 0 1" uv0="10000 10000" />
			<vertex pos="10 -10 0" normal="0 0 1" uv0="10000 0" />

			<triangle_set>
				<material_name>white</material_name>
				<tri>0 1 2</tri>
				<tri>0 2 3</tri>
			</triangle_set>
		</embedded>
	</mesh>
	
	<model>
		<pos>0 0 0</pos>
		<scale>1.0</scale>
		<mesh_name>groundmesh</mesh_name>
	</model>
	
	
	<mesh>
		<name>teapot</name>
		<scale>1</scale>
		<normal_smoothing>true</normal_smoothing>
		<external>
			<path>teapot.obj</path>
		</external>
	</mesh>
EOF

f = File.new("instancing_test2.igs", "w")

f << s

	W = 1.5
	H = 2.0

1000.times do 

	s = <<EOF
	<material>
		<name>default</name>
		<diffuse>
			<albedo>
				<constant>
					<rgb>
						<rgb>#{rand} #{rand} #{rand}</rgb>
						<gamma>1</gamma>
					</rgb>
				</constant>
			</albedo>
		</diffuse>
	</material>

	<!-- Define an instance -->
	<model>
		<rotation>
			<axis_rotation>
				<axis>#{rand} #{rand} #{rand + 0.1}</axis>
				<angle>#{rand * 30}</angle>
			</axis_rotation>
		</rotation>
		<pos>#{-W + rand*2.0*W} #{-W + rand*2.0*W} #{rand * H}</pos>
		<scale>0.5</scale>
		
		<mesh_name>teapot</mesh_name>
	</model>
EOF
	f << s
end
	
	
f << "</scene>"